# musrfit - muSR data analysis package #

### Contents ###

This is a data analysis package to analyze time differential muSR and beta-NMR data. 
Currently it allows the following things:

* setting up most commonly used fitting functions for muSR and beta-NMR
* fitting data, including global fits
* showing the fit results and the residuals
* showing the Fourier transform of the data
* extracting easily the fitting parameters to be used in other programs (gnuplot, qtiplot/origin, ...)
* allows to generate fitting input files for follow-up runs
* allows to generate global fitting input files based on a single run template
* allows to implement more sophisticated user functions 
  (e.g. GL vortex lattice, Meissner screening including low-energy muon stopping profiles)

### Currently supported platforms: ###

* Linux
* Mac OS X
* Windows - not really, only for the very brave ones

### Documentation ####

For a more exhaustive user documentation see:

  http://lmu.web.psi.ch/musrfit/user/MUSR/WebHome.html

### Contact ###

<andreas.suter@psi.ch>

